#include "algo_skel.h"

void init_algo(struct algo_skel* as, char* name) {
  for (int i = 0; i < sizeof(available_algo) / sizeof(available_algo[0]); i++) {
    if (strcmp(available_algo[i].name, name) == 0) {
      available_algo[i].init(as);
      return;
    }
  }
  fprintf(stderr, "Algorithm %s has not been found\n", name);
  exit(EXIT_FAILURE);
}

